#pragma language = extended
#include <include\io51fx.h>
#include <include\defines.h>
#include <include\settings.h>
#include <include\pins.h>
extern bit I2CERR;
extern bit   SHOUT     (void);   /* 뫠    ACC */
extern void  SHIN      (void);   /* ਭ    ACC */
extern bit   STARTCOND (void);
extern bit   POS_ACK   (void);
extern void  NEG_ACK   (void);
extern void  STOPCOND  (void);
#define FixAdr   0xA0   /* 䨪஢   EEPROM  I2C      */
#define maxTry   120    /* ᨬ쭮 ⢮ ⮪
                            㯠  設 I2C */

uchar OrMask, AndMask;  /* ᪨  , 뢠   WriteBlock */

void WaitEndWriteCycle (void)
  {
   uchar RetryCnt;

   for(RetryCnt=maxTry;RetryCnt!=0;RetryCnt--)
     {
      STARTCOND();      /* 뫠 START */
      ACC = FixAdr;
      I2CERR = SHOUT(); /* 뫠   */

      if (!I2CERR)
        {               /*  祭! */
         STOPCOND();    /* 뫠 STOP */
         break;         /*  ⮢  쭥襩 ࠡ */
        }
     }/* ,   横  */
  }

void WriteBlock (uint Adr, uchar NumBytes, uchar* Src)
/* ᯮ  ᪮७  ० Page Write 奬 24C08B/16B
    Microchip; NumBytes   1..16 */
  {
   uchar tmpByte;

   WaitEndWriteCycle();
   if(I2CERR)
      return;

   I2CERR = STARTCOND();
   if(I2CERR)
      return;

   tmpByte = Adr/256;
   ACC = (tmpByte << 1) | FixAdr;
                        /* ⨬ ணࠬ㥬    3..1
                              䨪஢  */
   ACC &= 0xfe;         /* 㪠    */
   if (SHOUT())         /* 諥  ன⢠ */
     {
      STOPCOND();
      I2CERR=TRUE;
      return;
     }
   ACC = (uchar)Adr;
   if (SHOUT())      /* 뫠  */
     {
      STOPCOND();
      I2CERR=TRUE;
      return;
     }/* if: 뢠, ᫨  ⢥ত */
   ACC = ((*Src|OrMask)&AndMask);
   if (SHOUT())      /* 뫠   */
     {
      STOPCOND();
      I2CERR=TRUE;
      return;
     }/* if: 뢠, ᫨  ⢥ত */
   Src++;
   NumBytes--;

   while (NumBytes != 0)
     {
      ACC = ((*Src|OrMask)&AndMask);
      if (SHOUT())      /* 뫠   */
        {
         STOPCOND();
         I2CERR=TRUE;
         return;
        }/* if: 뢠, ᫨  ⢥ত */
      Src++;
      NumBytes--;
     }
   STOPCOND();
   I2CERR=FALSE;
   return;
  }

void WriteByte (uint Adr, uchar Byte)
/* ணࠬ㫨   Byte   Adr.   ⠭
    I2CERR 砥  設  訡筮 ⢥ত 㥬
    ன⢠. */
  {
   uchar tmpByte;

   WaitEndWriteCycle();
   if(I2CERR)
      return;

   I2CERR = STARTCOND();
   if(I2CERR)
      return;

   tmpByte = Adr/256;
   ACC = (tmpByte << 1) | FixAdr;
                        /* ⨬ ணࠬ㥬    3..1
                              䨪஢  */
   ACC &= 0xfe;         /* 㪠    */
   if (SHOUT())         /* 諥  ன⢠ */
     {
      STOPCOND();
      I2CERR=TRUE;
      return;
     }/* if: 뢠, ᫨  ⢥ত */
   ACC = (uchar)Adr;
   if (SHOUT())      /* 뫠  */
     {
      STOPCOND();
      I2CERR=TRUE;
      return;
     }/* if: 뢠, ᫨  ⢥ত */
   ACC = Byte;
   if (SHOUT())      /* 뫠   */
     {
      STOPCOND();
      I2CERR=TRUE;
      return;
     }/* if: 뢠, ᫨  ⢥ত */
   STOPCOND();
   I2CERR=FALSE;
   return;
  }

uchar ReadCurrent (uchar BlockAdr)
/* ⠥   ⥪饬 .   ⠭
    I2CERR 砥  設  訡筮 ⢥ত 㥬
    ன⢠. */
  {
   uchar tmpByte;

   I2CERR = STARTCOND();
   if(I2CERR)
      return;

   tmpByte = BlockAdr;
   ACC = (tmpByte << 1) | FixAdr;
                        /* ⨬ ணࠬ㥬    3..1
                              䨪஢  */
   ACC |= 0x01;         /* 㪠  ⥭  */
   if (SHOUT())         /* 諥  ன⢠ */
     {
      STOPCOND();
      I2CERR=TRUE;
      return 0;
     }/* if: 뢠, ᫨  ⢥ত */
   SHIN();      /* ਬ    ACC             */
   NEG_ACK();   /*  뤠 ⢥ফ         */
   I2CERR = FALSE; /* 頥 䫠 訡                  */
   STOPCOND();
   return ACC;
  }

uchar ReadRandom (uint Adr)
/* ⠥   ந쭮  Adr.   ⠭
    I2CERR 砥  設  訡筮 ⢥ত 㥬
    ன⢠. */
  {
   uchar tmpByte;

   WaitEndWriteCycle();
   if(I2CERR)
      return;

   I2CERR = STARTCOND();
   if(I2CERR)
      return;

   tmpByte = Adr/256;
   ACC = (tmpByte << 1) | FixAdr;
                        /* ⨬ ணࠬ㥬    3..1
                              䨪஢  */
   ACC &= 0xfe;         /* 㪠   ( ᠬ 
                              㤥,  㦭 ⮫쪮 
                            ⠭  */
   if (SHOUT())         /* 諥  ன⢠ */
     {
      STOPCOND();
      I2CERR=TRUE;
      return 0;
     }/* if: 뢠, ᫨  ⢥ত */
   ACC = (uchar)Adr;
   if (SHOUT())      /* 뫠  */
     {
      STOPCOND();
      I2CERR=TRUE;
      return;
     }/* if: 뢠, ᫨  ⢥ত */
   ACC = ReadCurrent(Adr/256);
   return ACC;
  }

/*void LoadFromEE (bit TestCRC)
  {
   uchar Adress;
   uint  Summa;
   uchar IEacc;

   IEacc = IE;
   IE = 0;

   Adress = 0;
   SysMem[Adress]=ReadRandom24C02(Adress);
   Adress++;
   while (Adress!=0)
     {
      SysMem[Adress]=ReadCurrent();
      Adress++;
      if (I2CERR)
        {
         IE = IEacc;
         ErrorCycle();
        }
     }
   IE = IEacc;
   if (TestCRC)
     {
      Summa = CRC_DATA (SysMem, sizeof(SysMem)-2);
      if (Summa != SysMem[254]*256 + SysMem[255])
         ErrorCycle();
     }
  }

void SaveToEE (void)
  {
   uchar Adress;
   uint  Summa;
   uchar IEacc;

   IEacc = IE;
   IE = 0;

   Summa = CRC_DATA (SysMem, sizeof(SysMem)-2);
   SysMem[254] = Summa/256;
   SysMem[255] = (uchar)Summa;
   Adress = 0;
   wbWriteByte24C02 (Adress, SysMem[Adress]);
   Adress++;
   while (Adress!=0)
     {
      wbWriteByte24C02 (Adress, SysMem[Adress]);
      Adress++;
      if (I2CERR)
        {
         IE = IEacc;
         ErrorCycle();
        }
     }
   IE = IEacc;
  }*/

